Hot News aus dem CAD.de-Newsletter:

Mit Unterstützung durch:

  Foren auf CAD.de (alle Foren)
  SolidWorks
  Makro findet mehr Zuschnittselemente als angezeigt

Antwort erstellen  Neues Thema erstellen
CAD.de Login | Logout | Profil | Profil bearbeiten | Registrieren | Voreinstellungen | Hilfe | Suchen

Anzeige:

Darstellung des Themas zum Ausdrucken. Bitte dann die Druckfunktion des Browsers verwenden. | Suche nach Beiträgen nächster neuer Beitrag | nächster älterer Beitrag
Autor Thema:   Makro findet mehr Zuschnittselemente als angezeigt (431 mal gelesen)
CADFelix
Mitglied


Sehen Sie sich das Profil von CADFelix an!   Senden Sie eine Private Message an CADFelix  Schreiben Sie einen Gästebucheintrag für CADFelix

Beiträge: 5
Registriert: 24.09.2018

erstellt am: 24. Sep. 2018 17:12    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities


FalscheZuschnittselemente.zip

 
Hallo zusammen,

ich bin auf das Phänomen gestoßen, dass mein Makro (ist im Anhang) mehr Zuschnittselemente findet als im Featuremanager angezeigt wird.
Hintergrund: Ich möchte per Makro allen vorhandenen Zuschnittselementen eine fortlaufende Nummer in die Eigenschaften schreiben, um diese für eine ERP Kopplung zu nutzen.
Ich habe schon eine Fehlerursache ausgeschlossen. Es gibt keine Konfigurationen mehr, diese habe ich gelöscht. Das Verhalten tritt auch nicht bei jedem Teil auf.
Hat jemand schon einmal ein solches Verhalten gehabt, bzw. ist in meinem Makro ein grundsätzlicher Fehler?

Vielen Dank schon mal für eure Hilfe!
Gruß Felix

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

CADFelix
Mitglied


Sehen Sie sich das Profil von CADFelix an!   Senden Sie eine Private Message an CADFelix  Schreiben Sie einen Gästebucheintrag für CADFelix

Beiträge: 5
Registriert: 24.09.2018

Solidworks 2016 SP5
Soldiworks PDM 2016 SP5
Windows 10 64Bit
HP ZBook 17 G3
Intel Core i7-6820HQ
16 GB Arbeitsspeicher
NVIDIA Quadro M3000M

erstellt am: 24. Sep. 2018 17:15    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities

Hier noch das Makro:

Sub main()
    Dim swApp As SldWorks.SldWorks
    Dim swModel As SldWorks.ModelDoc2
    Dim swFeat As SldWorks.Feature
    Dim swCustPropMgr As SldWorks.CustomPropertyManager
    Dim strValue As String
   
    Dim Number As Integer
    Dim PosNumber As String
    Dim boolstatus As Boolean
     
    Set swApp = Application.SldWorks
    Set swModel = swApp.ActiveDoc
    Set swFeat = swModel.FirstFeature
   
    While Not swFeat Is Nothing
        If swFeat.GetType = 107 Then
            Set swCustPropMgr = swFeat.CustomPropertyManager
           
            Number = Number + 1
           
            PosNumber = Format(Number, "00")
            MsgBox swFeat.Name & " " & PosNumber
             
           
        End If
        Set swFeat = swFeat.GetNextFeature
       
        Wend
End Sub

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

Christian_W
Ehrenmitglied V.I.P. h.c.
Konstrukteur (Dipl-Ing)


Sehen Sie sich das Profil von Christian_W an!   Senden Sie eine Private Message an Christian_W  Schreiben Sie einen Gästebucheintrag für Christian_W

Beiträge: 2299
Registriert: 04.04.2001

SWX 2016sp5 WIN7-64
proAlpha6.2e/calinkV9
(Tactonworks)
(Medusa7, NesCAD2010,
solidEdge19) CSWP 12/2015

erstellt am: 25. Sep. 2018 12:02    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities Nur für CADFelix 10 Unities + Antwort hilfreich


UntergeordneteSchweisskonstr.PNG

 
Hallo Felix,

kannst du in der Zuschnittsliste mal den einen Ordner aufklappen?
ich würd jetzt vermuten, dass "Untergeordnete Schweißkonstruktionen" die vielen Ordner erklären ...

Gruß, Christian

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

CADFelix
Mitglied


Sehen Sie sich das Profil von CADFelix an!   Senden Sie eine Private Message an CADFelix  Schreiben Sie einen Gästebucheintrag für CADFelix

Beiträge: 5
Registriert: 24.09.2018

erstellt am: 25. Sep. 2018 12:11    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities


2018-09-2512_08_18-SOLIDWORKSProfessionell2016x64-Edition-001687299.SLDPRT_.jpg

 
Hallo Christian,

unter den Ordnern sind auch keine Schweißkonstruktionen.

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

Christian_W
Ehrenmitglied V.I.P. h.c.
Konstrukteur (Dipl-Ing)


Sehen Sie sich das Profil von Christian_W an!   Senden Sie eine Private Message an Christian_W  Schreiben Sie einen Gästebucheintrag für Christian_W

Beiträge: 2299
Registriert: 04.04.2001

SWX 2016sp5 WIN7-64
proAlpha6.2e/calinkV9
(Tactonworks)
(Medusa7, NesCAD2010,
solidEdge19) CSWP 12/2015

erstellt am: 25. Sep. 2018 12:30    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities Nur für CADFelix 10 Unities + Antwort hilfreich

Schade,
wäre wohl auch zu einfach gewesen ... 

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

Carsten1210
Mitglied
staatl. geprüfter Holztechniker


Sehen Sie sich das Profil von Carsten1210 an!   Senden Sie eine Private Message an Carsten1210  Schreiben Sie einen Gästebucheintrag für Carsten1210

Beiträge: 1333
Registriert: 24.07.2002

AutoCAD ACA 2019
Solidworks 2019 Sp2
Enterprise PDM 2019 Sp2
Pascam Woodworks
Visual Studio 2017 Pro
Windows 10 64Bit
Dell T3620
Intel Core i7-7700K
16 GB Arbeitsspeicher
2x Dell Ultrasharp U2415
Dell M4800

erstellt am: 25. Sep. 2018 12:30    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities Nur für CADFelix 10 Unities + Antwort hilfreich

Hi Felix,

Häng doch mal dein Teil an, dann kann man das damit testen.

Gruß, Carsten

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

CADFelix
Mitglied


Sehen Sie sich das Profil von CADFelix an!   Senden Sie eine Private Message an CADFelix  Schreiben Sie einen Gästebucheintrag für CADFelix

Beiträge: 5
Registriert: 24.09.2018

erstellt am: 25. Sep. 2018 13:40    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities

Carsten1210
Mitglied
staatl. geprüfter Holztechniker


Sehen Sie sich das Profil von Carsten1210 an!   Senden Sie eine Private Message an Carsten1210  Schreiben Sie einen Gästebucheintrag für Carsten1210

Beiträge: 1333
Registriert: 24.07.2002

AutoCAD ACA 2019
Solidworks 2019 Sp2
Enterprise PDM 2019 Sp2
Pascam Woodworks
Visual Studio 2017 Pro
Windows 10 64Bit
Dell T3620
Intel Core i7-7700K
16 GB Arbeitsspeicher
2x Dell Ultrasharp U2415
Dell M4800

erstellt am: 25. Sep. 2018 14:24    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities Nur für CADFelix 10 Unities + Antwort hilfreich

Hi Felix,

Lösch mal den Eintrag für die Schweisskonstruktion raus, dann kommen nur 2 Zuschnittselemente raus.

Gruß, Carsten

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

CADFelix
Mitglied


Sehen Sie sich das Profil von CADFelix an!   Senden Sie eine Private Message an CADFelix  Schreiben Sie einen Gästebucheintrag für CADFelix

Beiträge: 5
Registriert: 24.09.2018

erstellt am: 25. Sep. 2018 15:13    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities

@Carsten: Ja, es muss irgendetwas mit dem Schweißkonstruktions Feature zu tun haben. Darin wird sowas wie eine Historie gespeichert.

Ich bin mitlerweile auf die Funktion gestoßen, dass man die Volumenkörper unter den Zuschnittselementen abfragen kann.
Da die "Geister-Zuschnittselemente" keine Volmenkörer haben, führt diese Abfrage zum Erfolg. "IsEmpty(swFeat.GetSpecificFeature2.GetBodies)"
Das ungewöhnliche Verhalten erlärt es nicht, aber so komme ich weiter.

Danke für eure Hilfe!

Hier noch der angepasste Code:

Sub main()
    Dim swApp As SldWorks.SldWorks
    Dim swModel As SldWorks.ModelDoc2
    Dim swFeat As SldWorks.Feature
    Dim swCustPropMgr As SldWorks.CustomPropertyManager
    Dim strValue As String
   
    Dim Number As Integer
    Dim PosNumber As String
    Dim boolstatus As Boolean
     
    Set swApp = Application.SldWorks
    Set swModel = swApp.ActiveDoc
    Set swFeat = swModel.FirstFeature
   
    While Not swFeat Is Nothing
        If swFeat.GetType = 107 Then
       
            If Not IsEmpty(swFeat.GetSpecificFeature2.GetBodies) Then
                Set swCustPropMgr = swFeat.CustomPropertyManager
           
                Number = Number + 1
                PosNumber = Format(Number, "00")
               
                MsgBox swFeat.Name & " " & PosNumber
             
            End If
        End If
       
        Set swFeat = swFeat.GetNextFeature
       
        Wend
End Sub

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

Anzeige.:

Anzeige: (Infos zum Werbeplatz >>)

Darstellung des Themas zum Ausdrucken. Bitte dann die Druckfunktion des Browsers verwenden. | Suche nach Beiträgen

nächster neuerer Beitrag | nächster älterer Beitrag
Antwort erstellen


Diesen Beitrag mit Lesezeichen versehen ... | Nach anderen Beiträgen suchen | CAD.de-Newsletter

Administrative Optionen: Beitrag schliessen | Archivieren/Bewegen | Beitrag melden!

Fragen und Anregungen: Kritik-Forum | Neues aus der Community: Community-Forum

(c)2019 CAD.de | Impressum | Datenschutz